import 'package:fawry_sdk/model/payment_methods.dart';
import 'bill_item.dart';
import 'launch_customer_model.dart';
import 'launch_merchant_model.dart';

class FawryLaunchModel {
  bool allow3DPayment;
  List<BillItem> chargeItems;
  LaunchCustomerModel? launchCustomerModel;
  LaunchMerchantModel launchMerchantModel;
  bool skipLogin;
  bool skipReceipt;
  bool? payWithCardToken;
  PaymentMethods? paymentMethods;

  FawryLaunchModel({
    required this.allow3DPayment,
    required this.chargeItems,
    this.launchCustomerModel,
    required this.launchMerchantModel,
    required this.skipLogin,
    required this.skipReceipt,
    this.payWithCardToken,
    this.paymentMethods,
  });

  Map<String, dynamic> toJson() {
    List<Map<String, dynamic>> chargeItemsJson =
        chargeItems.map((item) => item.toJson()).toList();

    Map<String, dynamic>? launchCustomerJson =
        launchCustomerModel?.toJson();

    Map<String, dynamic> launchMerchantJson =
        launchMerchantModel.toJson();

    return {
      'allow3DPayment': allow3DPayment,
      'chargeItems': chargeItemsJson,
      'launchCustomerModel': launchCustomerJson,
      'launchMerchantModel': launchMerchantJson,
      'skipLogin': skipLogin,
      'skipReceipt': skipReceipt,
      'merchant': launchMerchantJson,
      'customer': launchCustomerJson,
      'skipCustomerInput': skipLogin,
      'allowVoucher': false,
      'payWithCardToken': payWithCardToken,
      'paymentWithCardToken': payWithCardToken,
      'paymentMethods': paymentMethods?.toShortString(),
      'paymentMethod': paymentMethods?.toShortString(),
    };
  }
}
